// bezier07Doc.cpp : implementation of the CBezierDoc class
//

#include "stdafx.h"
#include "SRAF.h"
#include "Bezier.h"

#include "BezierSet.h"
#include "BezierDoc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CBezierDoc

IMPLEMENT_DYNCREATE(CBezierDoc, CDocument)

BEGIN_MESSAGE_MAP(CBezierDoc, CDocument)
	//{{AFX_MSG_MAP(CBezierDoc)
	ON_COMMAND(ID_FILE_SAVE, OnFileSave)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBezierDoc construction/destruction

CBezierDoc::CBezierDoc()
{
	m_bMyModified = FALSE;
}

CBezierDoc::~CBezierDoc()
{
}

BOOL CBezierDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CBezierDoc serialization

void CBezierDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
	}
	else
	{
	}
}

/////////////////////////////////////////////////////////////////////////////
// CBezierDoc diagnostics

#ifdef _DEBUG
void CBezierDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CBezierDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CBezierDoc commands
 
BOOL CBezierDoc::OnOpenDocument(LPCTSTR lpszPathName) 
{
	/*if (!CDocument::OnOpenDocument(lpszPathName))
		return FALSE;*/
	
	// TODO: Add your specialized creation code here
	
	return TRUE;
}

BOOL CBezierDoc::SetBezierID(long lID)
{
	m_lID = lID;
	m_curveSet.m_strFilter.Format("nro_imagen = %d", m_lID);
	m_curveSet.m_strSort = "nro_curva";
	
	try
	{
		m_curveSet.Open();
	}
	catch(CDaoException* e)
	{
		AfxMessageBox(e->m_pErrorInfo->m_strDescription);
		e->Delete();
		return FALSE;
	}

	if (m_curveSet.IsOpen())
	{ 
		if (!m_curveSet.IsEOF()) {
			while(!m_curveSet.IsEOF())
			{
				m_curve.AddCurve(
					m_curveSet.m_X1,
					m_curveSet.m_Y1,
					m_curveSet.m_X2,
					m_curveSet.m_Y2,
					m_curveSet.m_X3,
					m_curveSet.m_Y3);
				m_curveSet.MoveNext();
			}
		}
		else {			
			m_curve.AddCurve(352, 245, 351, 196, 334, 160);
			m_curve.AddCurve(269, 160, 226, 159, 187, 182);
			m_curve.AddCurve(186, 247, 188, 289, 210, 319);
			m_curve.AddCurve(273, 322, 334, 320, 353, 293);
		}
		m_curve.Close();

		//m_curveSet.Close(); // se cierra en onclose
	}
	return TRUE;
}

BOOL CBezierDoc::OnSaveDocument(LPCTSTR lpszPathName) 
{
	if (m_curveSet.IsOpen()) {
		/* Eliminar todas las curvas actuales */
		m_curveSet.Requery();
		while (!m_curveSet.IsEOF()) {
			m_curveSet.Delete();
			m_curveSet.MoveNext();
		}
		/* Guardar las nuevas curvas */
		CPoint p1, p2, p3;
		for (int i = 0; i < m_curve.GetCurveNumber(); i++) {
			m_curveSet.AddNew();
			m_curve.GetCurve(i, &p1, &p2, &p3);
			m_curveSet.m_nro_imagen = m_lID;
			m_curveSet.m_nro_curva = i;
			m_curveSet.m_X1 = p1.x;
			m_curveSet.m_Y1 = p1.y;
			m_curveSet.m_X2 = p2.x;
			m_curveSet.m_Y2 = p2.y;
			m_curveSet.m_X3 = p3.x;
			m_curveSet.m_Y3 = p3.y;
			m_curveSet.Update();
		}
		/* Setear como no modificado */
		SetModifiedFlag(FALSE);
		return TRUE;
	}
	else {
		AfxMessageBox("Base de datos no disponible para guardar");
		return FALSE;
	}

	//return CDocument::OnSaveDocument(lpszPathName);
}

BOOL CBezierDoc::SaveModified() 
{
	if (m_bMyModified) {
		CString str;
		str.Format("Guardar cambios a %s?", GetTitle());
		
		int ans = AfxMessageBox(str, MB_YESNOCANCEL | MB_ICONEXCLAMATION);
		if (ans == IDCANCEL)
			return FALSE;
		else if (ans == IDNO)
			return TRUE;
		else 
			return OnSaveDocument(NULL);
	}
	return TRUE;

	//return CDocument::SaveModified();
}

void CBezierDoc::OnCloseDocument() 
{
	if (m_curveSet.IsOpen())
		m_curveSet.Close();
	
	CDocument::OnCloseDocument();
}

void CBezierDoc::OnFileSave() 
{
	OnSaveDocument(NULL);
}
