// bezier07Doc.h : interface of the CBezierDoc class
//
/////////////////////////////////////////////////////////////////////////////
class CBezierSet;

class CBezierDoc : public CDocument
{
protected: // create from serialization only
	CBezierDoc();
	DECLARE_DYNCREATE(CBezierDoc)

private:
	BOOL m_bMyModified;
	long m_lID;
	

// Attributes
public:
	CBezierSet m_curveSet;
	CBezier m_curve;

// Operations
public:
	CBezier* GetBezier() {
		return &m_curve;
	}
	void SetModifiedFlag(BOOL bModified = TRUE) {
		m_bMyModified = bModified;
		CDocument::SetModifiedFlag(bModified);
	}

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CBezierDoc)
	public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);
	virtual BOOL OnOpenDocument(LPCTSTR lpszPathName);
	virtual BOOL OnSaveDocument(LPCTSTR lpszPathName);
	virtual void OnCloseDocument();
	protected:
	virtual BOOL SaveModified();
	//}}AFX_VIRTUAL

// Implementation
public:
	long GetBezierID() { return m_lID; }
	BOOL SetBezierID(long ID);
	virtual ~CBezierDoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CBezierDoc)
	afx_msg void OnFileSave();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////
