// BezierSet.cpp : implementation file
//

#include "stdafx.h"
#include "SRAF.h"
#include "BezierSet.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CBezierSet

IMPLEMENT_DYNAMIC(CBezierSet, CDaoRecordset)

CBezierSet::CBezierSet(CDaoDatabase* pdb)
	: CDaoRecordset(pdb)
{
	//{{AFX_FIELD_INIT(CBezierSet)
	m_nro_imagen = 0;
	m_nro_curva = 0;
	m_X1 = 0;
	m_X2 = 0;
	m_X3 = 0;
	m_Y1 = 0;
	m_Y2 = 0;
	m_Y3 = 0;
	m_nFields = 8;
	//}}AFX_FIELD_INIT
	m_nDefaultType = dbOpenDynaset;
}


CString CBezierSet::GetDefaultDBName()
{
	//return _T("D:\\Archivos de programa\\DevStudio\\MyProjects\\SRAF\\imagenes.mdb");
	//AfxGetApp()->m_pszExeName
	//return _T("imagenes.mdb");
	return ((CSRAFApp*)AfxGetApp())->m_pszDBPath;
}

CString CBezierSet::GetDefaultSQL()
{
	return _T("[Curvas]");
}

void CBezierSet::DoFieldExchange(CDaoFieldExchange* pFX)
{
	//{{AFX_FIELD_MAP(CBezierSet)
	pFX->SetFieldType(CDaoFieldExchange::outputColumn);
	DFX_Long(pFX, _T("[nro_imagen]"), m_nro_imagen);
	DFX_Short(pFX, _T("[nro_curva]"), m_nro_curva);
	DFX_Long(pFX, _T("[X1]"), m_X1);
	DFX_Long(pFX, _T("[X2]"), m_X2);
	DFX_Long(pFX, _T("[X3]"), m_X3);
	DFX_Long(pFX, _T("[Y1]"), m_Y1);
	DFX_Long(pFX, _T("[Y2]"), m_Y2);
	DFX_Long(pFX, _T("[Y3]"), m_Y3);
	//}}AFX_FIELD_MAP
}

/////////////////////////////////////////////////////////////////////////////
// CBezierSet diagnostics

#ifdef _DEBUG
void CBezierSet::AssertValid() const
{
	CDaoRecordset::AssertValid();
}

void CBezierSet::Dump(CDumpContext& dc) const
{
	CDaoRecordset::Dump(dc);
}
#endif //_DEBUG
