class CCanny : public CEdgeDetector
{
	CImage m_magim, m_oriim;

public:
	float m_sigma;
	int m_low, m_high;

protected:
	DECLARE_DYNAMIC(CCanny)

	int Trace(CImage& img, int i, int j, int low);
	float Gauss(float x);
	float DGauss(float x);
	float MeanGauss(float x);
	bool Hysteresis(CImage& img);
	bool Canny(CImage& img);
	void SeperableConvolution(CImage& img, float *gau, int width, 
		float **smx, float **smy);
	void DxySeperableConvolution(float** im, float *gau,  
			int width, float **sm, int which);
	void NonMaxSuppress(float **dx, float **dy);
	void EstimateThresh(int* low, int* high);
	float Norm(float x, float y);

public:
	CCanny();
	CCanny(CCanny&);
	~CCanny();
	bool Detect(CImage& im);
	char* GetName() {return "Canny";};
	void GetParams(CString& params);

#ifdef _DEBUG
    virtual void Dump( CDumpContext& dc ) const;
#endif
};