#include "Dib.h"

class CStrElement;

class CImage : public CObject
{
	BYTE** m_data;
	int m_nRows, m_nCols;

public:
	enum COLOR {BLACK = 0, WHITE = 255};

	CImage();
	CImage(const CImage& x);
	CImage(int rows, int cols);
	CImage(CDib &dib);
	
	bool Create(int rows, int cols);
	void Free();

	~CImage() { Free(); }
	int GetRows() const { return m_nRows; }
	int GetCols() const { return m_nCols; }
	BYTE* operator[](int i) const { return m_data[i]; }

	bool TestRange(int row, int col) const;
	void operator=(const CImage& rvalue);
	void operator=(const int c);

	void operator+=(const CStrElement& elm);
	void operator-=(const CStrElement& elm);

	void CopyToDib(CDib& dib) {
		for (int i = 0; i < m_nRows; i++)
			memcpy(dib[i], m_data[i], m_nCols);
	}
	void operator=(CDib& dib) {
		if (m_nRows != dib.Alto() || m_nCols != dib.Ancho())
			Create(dib.Alto(), dib.Ancho());

		for (int i = 0; i < m_nRows; i++)
			memcpy(m_data[i], dib[i], m_nCols);
	}
};

class CStrElement: public CImage
{
	int m_nOrgRow, m_nOrgCol;

public:
	CStrElement(int rows, int cols, int org_row, int org_col) 
	{
		Create(rows, cols);
		m_nOrgRow = org_row;
		m_nOrgCol = org_col;
	}
	int GetOrgRow() const {return m_nOrgRow;}
	int GetOrgCol() const {return m_nOrgCol;}
	void operator=(const int c) { CImage::operator=(c); }
};