// ImageBar.h: interface for the CImageBar class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_IMAGEBAR_H__91B25683_9366_11D1_9F03_AB82353DF370__INCLUDED_)
#define AFX_IMAGEBAR_H__91B25683_9366_11D1_9F03_AB82353DF370__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "ImageSet.h"
#include <afxtempl.h>

class CImageBar : public CDialogBar  
{
	enum ICON {GROUP, ITEM, MARK_GROUP, MARK_ITEM};
	CGroupSet m_grpSet;
	CImageSet m_imgSet;
	CImageList m_imageList;
	//CList<HTREEITEM, HTREEITEM> m_selectedList;
	CBitmap m_bmpNewGrp, m_bmpAdd, m_bmpDel;

	CTreeCtrl* GetCtrl() {
		return (CTreeCtrl*) GetDlgItem(IDC_TREE);
	}
	
	virtual CSize CalcFixedLayout( BOOL bStretch, BOOL bHorz );

	HTREEITEM InsertItem(CString, LPARAM, int, int, 
		HTREEITEM = TVI_ROOT , HTREEITEM = TVI_LAST);
public:
	CImageBar();
	~CImageBar();
	
	bool Create(CWnd*);
	void Populate();
	void MarkItem(HTREEITEM hItem);
	void EditLabel(HTREEITEM item);
	BOOL DelItem();
	bool AddGroup();
	HTREEITEM EditItem(LPNMHDR pnmhdr, LRESULT *pLResult);
	HTREEITEM AddItem();
	HTREEITEM GetFirstMarkedItem();
	HTREEITEM GetNextMarkedItem(HTREEITEM hItem);

public: /* public inline functions */
	HTREEITEM GetSelectedItem() {
		return GetCtrl()->GetSelectedItem();
	}
	bool IsGroup(HTREEITEM hItem) {
		return (GetCtrl()->GetParentItem(hItem) == NULL);
	}
	CString GetItemText(HTREEITEM hItem) {
		return GetCtrl()->GetItemText(hItem);
	}
	
	DWORD GetItemData(HTREEITEM hItem) {
		return GetCtrl()->GetItemData(hItem);
	}

	bool IsMarked(HTREEITEM hItem) {
		int nImage, nSelectedImage;
		GetCtrl()->GetItemImage(hItem, nImage, nSelectedImage);
		return (nImage == MARK_ITEM || nImage == MARK_GROUP);
	}
};

#endif // !defined(AFX_IMAGEBAR_H__91B25683_9366_11D1_9F03_AB82353DF370__INCLUDED_)
