// OptionsDlg.cpp : implementation file
//

#include "stdafx.h"
#include "SRAF.h"
#include "OptionsDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// COptionsDlg dialog


COptionsDlg::COptionsDlg(CWnd* pParent /*=NULL*/)
	: CDialog(COptionsDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(COptionsDlg)
	m_fSigma = 0.0f;
	m_bDoHysteresis = FALSE;
	m_nThinning = 0;
	m_nWidth = 0;
	m_strDetector = _T("");
	m_dRatio = 0.0;
	m_dSmoothing = 0.0;
	//}}AFX_DATA_INIT
}


void COptionsDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(COptionsDlg)
	DDX_Control(pDX, IDC_LOW, m_editLow);
	DDX_Control(pDX, IDC_HI, m_editHi);
	DDX_Text(pDX, IDC_SIGMA, m_fSigma);
	DDV_MinMaxFloat(pDX, m_fSigma, 0.f, 255.f);
	DDX_Check(pDX, IDC_HYSTERESIS, m_bDoHysteresis);
	DDX_Text(pDX, IDC_THINNING, m_nThinning);
	DDX_Text(pDX, IDC_WIDTH, m_nWidth);
	DDX_CBString(pDX, IDC_DETECTOR, m_strDetector);
	DDX_Text(pDX, IDC_RATIO, m_dRatio);
	DDX_Text(pDX, IDC_SMOOTHING, m_dSmoothing);
	//}}AFX_DATA_MAP
	if (m_strDetector == "Canny") {
		DDX_Text(pDX, IDC_HI, m_nCannyHi);
		DDX_Text(pDX, IDC_LOW, m_nCannyLow);
	}
	else {
		DDX_Text(pDX, IDC_HI, m_dShenHi);
		DDX_Text(pDX, IDC_LOW, m_dShenLow);
	}
}


BEGIN_MESSAGE_MAP(COptionsDlg, CDialog)
	//{{AFX_MSG_MAP(COptionsDlg)
	ON_CBN_SELCHANGE(IDC_DETECTOR, OnSelchangeDetector)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// COptionsDlg message handlers

BOOL COptionsDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	/*CComboBox* pCBox = (CComboBox*)GetDlgItem(IDC_DETECTOR);

	pCBox->AddString("Shen-Castan (ISEF)");
	pCBox->AddString("Canny");
	pCBox->AddString("abc");
	pCBox->SetItemHeight(-1, 50);*/
	
	((CSpinButtonCtrl*)GetDlgItem(IDC_HI_SPIN))->SetRange(0, 100);
	((CSpinButtonCtrl*)GetDlgItem(IDC_LOW_SPIN))->SetRange(0, 100);

	((CSpinButtonCtrl*)GetDlgItem(IDC_SIGMA_SPIN))->SetRange(0, 100);
	((CSpinButtonCtrl*)GetDlgItem(IDC_RATIO_SPIN))->SetRange(0, 100);
	((CSpinButtonCtrl*)GetDlgItem(IDC_SMOOTHING_SPIN))->SetRange(0, 100);
	((CSpinButtonCtrl*)GetDlgItem(IDC_WIDTH_SPIN))->SetRange(0, 100);
	((CSpinButtonCtrl*)GetDlgItem(IDC_THINNING_SPIN))->SetRange(0, 100);

	OnSelchangeDetector();
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void COptionsDlg::OnSelchangeDetector() 
{
	CString str, strVal;
	BOOL bEnable;
	CComboBox* pCBox = (CComboBox*)GetDlgItem(IDC_DETECTOR);
	int nIndex = pCBox->GetCurSel();
	
	if (nIndex == CB_ERR) 
		return;

	pCBox->GetLBText(nIndex, str);
	
	if (str == "Canny") {
		bEnable = TRUE;
		strVal.Format("%d", m_nCannyHi);
		m_editHi.SetWindowText(strVal);
		strVal.Format("%d", m_nCannyLow);
		m_editLow.SetWindowText(strVal);
	}
	else {
		bEnable = FALSE;
		strVal.Format("%.3f", m_dShenHi);
		m_editHi.SetWindowText(strVal);
		strVal.Format("%.3f", m_dShenLow);
		m_editLow.SetWindowText(strVal);
	}
	
	GetDlgItem(IDC_SIGMA)->EnableWindow(bEnable);
	GetDlgItem(IDC_HYSTERESIS)->EnableWindow(!bEnable);
	GetDlgItem(IDC_RATIO)->EnableWindow(!bEnable);
	GetDlgItem(IDC_SMOOTHING)->EnableWindow(!bEnable);
	GetDlgItem(IDC_WIDTH)->EnableWindow(!bEnable);
	GetDlgItem(IDC_THINNING)->EnableWindow(!bEnable);

	GetDlgItem(IDC_SIGMA_TXT)->EnableWindow(bEnable);
	GetDlgItem(IDC_RATIO_TXT)->EnableWindow(!bEnable);
	GetDlgItem(IDC_SMOOTHING_TXT)->EnableWindow(!bEnable);
	GetDlgItem(IDC_WIDTH_TXT)->EnableWindow(!bEnable);
	GetDlgItem(IDC_THINNING_TXT)->EnableWindow(!bEnable);

	GetDlgItem(IDC_SIGMA_SPIN)->EnableWindow(bEnable);
	GetDlgItem(IDC_RATIO_SPIN)->EnableWindow(!bEnable);
	GetDlgItem(IDC_SMOOTHING_SPIN)->EnableWindow(!bEnable);
	GetDlgItem(IDC_WIDTH_SPIN)->EnableWindow(!bEnable);
	GetDlgItem(IDC_THINNING_SPIN)->EnableWindow(!bEnable);
}
