// ProgressDlg.cpp : implementation file
//

#include "stdafx.h"
#include "SRAF.h"
#include "ProgressDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CProgressDlg dialog

CProgressDlg::CProgressDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CProgressDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CProgressDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	m_pWnd = NULL;
	m_bHoldDlg = false;
	m_bCancel = false;
}

CProgressDlg::CProgressDlg()
{
	m_pWnd = NULL;
	m_bHoldDlg = false;
	m_bCancel = false;
}

void CProgressDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CProgressDlg)
	DDX_Control(pDX, IDC_PROGRESS, m_progress);
	DDX_Control(pDX, IDC_TASK, m_task);
	//}}AFX_DATA_MAP
}

#define WM_DETECTION_STATUS WM_USER + 6

BEGIN_MESSAGE_MAP(CProgressDlg, CDialog)
	//{{AFX_MSG_MAP(CProgressDlg)
	ON_BN_CLICKED(IDC_CANCEL_RECOGNIZING, OnCancelRecognizing)
	ON_BN_CLICKED(IDC_MANTENER, OnMantener)
	//}}AFX_MSG_MAP
	ON_MESSAGE(WM_DETECTION_STATUS, OnUpdateStatus)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CProgressDlg message handlers

void CProgressDlg::AddTask(LPCTSTR str)
{
	TCHAR	szt[100];
	int		nLastChar;
	int		cLines;

	//if (m_task.GetLineCount() >= m_totalLines)
	//{
		//m_task.SetSel(0, m_task.LineLength(0), TRUE/*bNoScroll*/);  // select the first line
		//m_task.Clear();  // and remove it
	//}

	nLastChar = m_task.LineIndex((cLines = m_task.GetLineCount() - 1)) + m_task.LineLength(cLines);
	_stprintf(szt, _T("%s\x0D\x0A"), str);
	m_task.SetSel(nLastChar, nLastChar, FALSE /*TRUE = bNoScroll*/);
	m_task.ReplaceSel(szt);
}

void CProgressDlg::SetProgress(UINT pos)
{
	m_progress.SetPos(pos);
}

void CProgressDlg::Reset()
{
	m_progress.SetPos(0);
	m_task.SetWindowText("");
}

void CProgressDlg::Create(CWnd* pWnd, LPCTSTR caption) 
{
	CString str;
	
	m_pWnd = pWnd;
	m_bCancel = false;
	
	if (GetSafeHwnd() == 0) {
		CDialog::Create(CProgressDlg::IDD, m_pWnd);
		m_bHoldDlg = false;
	}
	else
		Reset();

	SetWindowText(caption);
}

void CProgressDlg::OnCancel() 
{
	ShowWindow(SW_HIDE);
}

void CProgressDlg::Close() 
{
	if (!m_bHoldDlg)
		DestroyWindow();
}

void CProgressDlg::OnCancelRecognizing() 
{
	m_bCancel = true;
}

BOOL CProgressDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	//m_task.SetLimitText(1);
	
	//((CButton*)GetDlgItem(IDC_MANTENER))->SetButtonStyle(BS_3STATE);
	
	return TRUE;
}

void CProgressDlg::OnMantener() 
{
	if (m_bHoldDlg) 
		GetDlgItem(IDC_MANTENER)->SetWindowText("Mantener");
	else
		GetDlgItem(IDC_MANTENER)->SetWindowText("Cerrar auto.");

	m_bHoldDlg = !m_bHoldDlg;
}

LRESULT CProgressDlg::OnUpdateStatus(WPARAM wParam, LPARAM lParam)
{
	SetProgress((int) wParam);
	if (lParam) AddTask((LPCTSTR) lParam);

	if (m_bCancel) return 1L;
	else return 0L;
}
