// SRAFDoc.cpp : implementation of the CSRAFDoc class
//

#include "stdafx.h"
#include "SRAF.h"

#include "Image.h"
#include "EdgeDetector.h"
#include "Canny.h"
#include "Shen.h"
#include "SRAFDoc.h"
#include "OptionsDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSRAFDoc

IMPLEMENT_DYNCREATE(CSRAFDoc, CDocument)

BEGIN_MESSAGE_MAP(CSRAFDoc, CDocument)
	//{{AFX_MSG_MAP(CSRAFDoc)
	ON_COMMAND(ID_RECONOCIMIENTO_OPCIONES, OnOptions)
	ON_COMMAND(ID_RECONOCIMIENTO_RESTAURAR_IMAGEN, OnReloadImage)
	ON_UPDATE_COMMAND_UI(ID_RECONOCIMIENTO_RESTAURAR_IMAGEN, OnUpdateReloadImage)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSRAFDoc construction/destruction

CCanny CSRAFDoc::m_canny;
CShen CSRAFDoc::m_shen;
CSRAFDoc::EDGE_DETECTOR CSRAFDoc::m_detector = CSRAFDoc::SHEN;

CSRAFDoc::CSRAFDoc()
{
}

CSRAFDoc::~CSRAFDoc()
{
}

BOOL CSRAFDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CSRAFDoc serialization

void CSRAFDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
	}
	else
	{
	}
}

/////////////////////////////////////////////////////////////////////////////
// CSRAFDoc diagnostics

#ifdef _DEBUG
void CSRAFDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CSRAFDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CSRAFDoc commands

BOOL CSRAFDoc::OnOpenDocument(LPCTSTR lpszPathName) 
{
	if (!CDocument::OnOpenDocument(lpszPathName))
		return FALSE;
	
	return m_dib.Cargar(lpszPathName);
}

void CSRAFDoc::OnOptions() 
{
	COptionsDlg dlg;

	dlg.m_fSigma = m_canny.m_sigma;
	dlg.m_nCannyHi = m_canny.m_high;
	dlg.m_nCannyLow = m_canny.m_low;
	
	dlg.m_dShenHi = m_shen.m_high_thresh;
	dlg.m_dShenLow = m_shen.m_low_thresh;
	dlg.m_bDoHysteresis = m_shen.m_do_hysteresis;
	dlg.m_dRatio = m_shen.m_ratio;
	dlg.m_dSmoothing = m_shen.m_b;
	dlg.m_nWidth = m_shen.m_window_size;
	dlg.m_nThinning = m_shen.m_thinFactor;

	if (m_detector == CANNY) 
		dlg.m_strDetector = "Canny";
	else
		dlg.m_strDetector = "Shen";
	
	if (dlg.DoModal() == IDOK) {
		if (dlg.m_strDetector == "Canny") {
			m_detector = CANNY;
			m_canny.m_sigma = dlg.m_fSigma;
			m_canny.m_high = dlg.m_nCannyHi;
			m_canny.m_low = dlg.m_nCannyLow;
		}
		else {
			m_detector = SHEN;
			m_shen.m_high_thresh = dlg.m_dShenHi;
			m_shen.m_low_thresh = dlg.m_dShenLow;
			m_shen.m_do_hysteresis = dlg.m_bDoHysteresis;
			m_shen.m_ratio = dlg.m_dRatio;
			m_shen.m_b = dlg.m_dSmoothing;
			m_shen.m_window_size = dlg.m_nWidth;
			m_shen.m_thinFactor = dlg.m_nThinning;
		}
	}
}

void CSRAFDoc::OnReloadImage() 
{
	OnOpenDocument(GetPathName());
	UpdateAllViews(NULL, 1);
}

void CSRAFDoc::OnUpdateReloadImage(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(GetPathName().IsEmpty() ? FALSE:TRUE);
}
