class CShen : public CEdgeDetector
{
	float **m_lap;							// keep track of laplacian of image
	CImage m_im, m_res;

public:	
	double m_b;							// smoothing factor 0 < b < 1
	double m_low_thresh, m_high_thresh;	// threshold for hysteresis
	double m_ratio;
	int m_window_size;
	int m_do_hysteresis;
	int m_thinFactor;

protected:
	DECLARE_DYNAMIC(CShen)
	
	bool Shen();
	void ComputeISEF(float **x, float **y);
	void ApplyISEFvertical(float **x, float **y, float **A, float **B);
	void ApplyISEFhorizontal(float **x, float **y, float **A, float **B);
	void ComputeBli(float **buff1, float **buff2, CImage&);
	void LocateZeroCrossings(float **orig, float **smoothed, CImage& bli);
	void ThresholdEdges(float **in);
	int MarkConnected(int i, int j,int level, double low_thresh);
	int IsCandidateEdge(CImage& buff, float **orig, int row, int col);
	float ComputeAdaptiveGradient(CImage& BLI_buffer, float **orig_buffer, 
		int row, int col);
	void EstimateThresh(double *low, double *hi);

public:
	CShen();
	CShen(CShen&);
	~CShen();
	bool Detect(CImage& src);
	char* GetName() {return "Shen-Castan (ISEF)";}
	void GetParams(CString& params);

/*#ifdef _DEBUG
    virtual void Dump( CDumpContext& dc ) const;
#endif*/
};
